/**
 * RokNewsPager Module
 *
 * @package		Joomla
 * @subpackage	RokNewsPager Module
 * @copyright Copyright (C) 2009 RocketTheme. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see RT-LICENSE.php
 * @author RocketTheme, LLC
 *
 */

var RokNewsPagerStorage = [];
var RokNewsPager = new Class({
    version: 1.5,
    options: {
        autoupdate: true,
        delay: 3000,
        accordion: false
    },
    initialize: function (e) {
        var f = this;
        this.setOptions(e);
        this.storage = RokNewsPagerStorage;
        this.elements = $$('.roknewspager');
        this.modules = this.elements.getParent()
            .getParent();
        this.spinners = $$('.roknewspager-spinner');
        this.arrows = {
            'prev': $$('.roknewspager-prev'),
            'next': $$('.roknewspager-next')
        };
        this.pages = $$('.roknewspager-numbers');
        this.current = [];
        this.overlay = [];
        this.effects = [];
        this.ajax = [];
        this.timer = [];
        this.accordions = [];
        this.elements.each(function (d, i) {
            this.ajax.push(new Ajax(this.storage[i]['url'], {
                method: 'get'
            }));
            this.overlay.push(new Element('div', {
                'class': 'roknewspager-overlay'
            })
                .setStyles({
                'opacity': 0,
                'display': 'block',
                'position': 'absolute',
                'top': 0,
                'left': 0
            })
                .inject(d, 'before'));
            d.getParent()
                .setStyle('overflow', 'hidden');
            this.effects.push(new Fx.Style(this.overlay[i], 'opacity', {
                'duration': 200
            })
                .set(1));
            this.current.push(0);
            this.accordions.push(false);
            this.events(i);
            this.ajax[i].addEvent('onComplete', function (a) {
                this.complete(a, i)
            }.bind(this));
            if (RokNewsPagerStorage[i].autoupdate) {
                this.ajax[i].addEvent('onRequest', function () {
                    $clear(this.timer[i])
                }.bind(this));
                this.modules[i].addEvents({
                    'mouseenter': function () {
                        $clear(this.timer[i])
                    }.bind(this),
                    'mousemove': function () {
                        $clear(this.timer[i])
                    }.bind(this),
                    'mouseleave': function () {
                        $clear(this.timer[i]);
                        this.timer[i] = this.next.periodical(RokNewsPagerStorage[i].delay, this, i)
                    }.bind(this)
                });
                this.timer[i] = this.next.periodical(RokNewsPagerStorage[i].delay, this, i)
            }
            if (RokNewsPagerStorage[i].accordion) {
                this.accordions[i] = new Accordion(d.getElements('.roknewspager-toggle'), d.getElements('.roknewspager-div'), {
                    opacity: false,
                    onActive: function (a) {
                        var b = d.getElements('.roknewspager-h3')
                            .getParent();
                        if (this.togglers.length) {
                            $$(this.togglers)
                                .removeClass('roknewspager-toggle-active');
                            d.getChildren()
                                .removeClass('active')
                        }
                        a.addClass('roknewspager-toggle-active');
                        var c = this.togglers.indexOf(a);
                        d.getChildren()[c].addClass('active')
                    }
                }, d)
            }
        }, this)
    },
    complete: function (a, b) {
        if (RokNewsPagerStorage[b].autoupdate) {
            $clear(this.timer[b]);
            this.timer[b] = this.next.periodical(RokNewsPagerStorage[b].delay, this, b)
        }
        this.overlay[b].setStyles({
            'width': this.elements[b].getSize()
                .size.x + this.elements[b].getParent()
                .getStyle('padding-left')
                .toInt() + this.elements[b].getParent()
                .getStyle('padding-right')
                .toInt(),
            'height': (window.ie6) ? this.elements[b].getSize()
                .size.x : 3000
        });
        var c = new Element('div')
            .setHTML(a);
        if (!RokNewsPagerStorage[b].accordion) c.getElements('.roknewspager > li')
            .inject(this.elements[b].empty());
        else c.getElement('.roknewspager')
            .getChildren()
            .inject(this.elements[b].empty());
        this.hideSpinner(b);
        this.effects[b].start(0)
    },
    events: function (c) {
        if (!this.pages[c]) return;
        var d = this.pages[c].getElements('li');
        d.each(function (b, i) {
            b.addEvent('click', function () {
                if (b.hasClass('active')) return;
                if (!i) {
                    this.arrows.prev[c].addClass('roknewspager-prev-disabled')
                        .removeClass('roknewspager-prev');
                    this.arrows.next[c].addClass('roknewspager-next')
                        .removeClass('roknewspager-next-disabled')
                } else if (i == d.length - 1) {
                    this.arrows.next[c].addClass('roknewspager-next-disabled')
                        .removeClass('roknewspager-next');
                    this.arrows.prev[c].addClass('roknewspager-prev')
                        .removeClass('roknewspager-prev-disabled')
                } else {
                    this.arrows.prev[c].addClass('roknewspager-prev')
                        .removeClass('roknewspager-prev-disabled');
                    this.arrows.next[c].addClass('roknewspager-next')
                        .removeClass('roknewspager-next-disabled')
                }
                this.showSpinner(c);
                this.pages[c].getElements('li')
                    .removeClass('active');
                b.addClass('active');
                this.current[c] = i;
                this.overlay[c].setStyles({
                    'opacity': 0.9,
                    'display': 'block'
                });
                var a = this.elements[c].getProperty('perpage') * i;
                this.ajax[c].url = this.storage[c]['url'].replace("_OFFSET_", a);
                this.ajax[c].request()
            }.bind(this))
        }, this);
        this.arrows.prev[c].addClass('roknewspager-prev-disabled')
            .removeClass('roknewspager-prev');
        this.arrows.prev[c].addEvent('click', function () {
            var a = this.current[c];
            if (RokNewsPagerStorage[c].autoupdate) {
                $clear(this.timer[c])
            }
            this.arrows.next[c].addClass('roknewspager-next')
                .removeClass('roknewspager-next-disabled');
            if (!a || a - 1 == 0) {
                this.arrows.prev[c].addClass('roknewspager-prev-disabled')
                    .removeClass('roknewspager-prev')
            }
            if (d[a - 1]) d[a - 1].fireEvent('click')
        }.bind(this));
        this.arrows.next[c].addEvent('click', function () {
            var a = this.current[c];
            if (RokNewsPagerStorage[c].autoupdate) {
                $clear(this.timer[c])
            }
            this.arrows.prev[c].addClass('roknewspager-prev')
                .removeClass('roknewspager-prev-disabled');
            if (a == d.length - 1 || a + 1 == d.length - 1) {
                this.arrows.next[c].addClass('roknewspager-next-disabled')
                    .removeClass('roknewspager-next')
            }
            if (d[a + 1]) d[a + 1].fireEvent('click')
        }.bind(this))
    },
    showSpinner: function (a) {
        return this.spinners[a].setStyle('display', 'block')
    },
    hideSpinner: function (a) {
        if (RokNewsPagerStorage[a].accordion) this.accordionInit(a);
        return this.spinners[a].setStyle('display', 'block')
    },
    add: function (a) {
        return this.storage.push($merge(this.options, a))
    },
    next: function (a) {
        if (this.current[a] == this.pages[a].getElements('li')
            .length - 1) this.current[a] = -1;
        this.arrows.next[a].fireEvent('click')
    },
    accordionInit: function (c) {
        this.accordions[c].elements = [];
        this.accordions[c].togglers = [];
        this.accordions[c].previous = -1;
        this.elements[c].getElements('.roknewspager-h3')
            .getParent()
            .each(function (a, i) {
            var b = a.getFirst(),
                toggle = a.getFirst()
                    .getElement('.roknewspager-toggle'),
                pane = a.getLast();
            this.accordions[c].addSection(toggle, pane);
            b.inject(a);
            toggle.inject(b);
            pane.inject(a)
        }, this);
        this.accordions[c].display(0)
    }
});
RokNewsPager.implement(new Options, new Events);
window.addEvent('domready', function () {
    new RokNewsPager()
});